"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Websocket = void 0;
const WebsocketClient = require('websocket').client;
class Websocket {
    constructor(opts) {
        this.opts = opts;
        this.ws = new WebsocketClient();
        this.fuConnection = new Promise((resolve, reject) => {
            this.ws.on('connect', (connection) => {
                connection.on('close', () => {
                    reject('websocket closed ' + this.url);
                });
                connection.on('message', (data) => {
                    this.opts.receive(data.utf8Data);
                });
                function sendRaw(data) {
                    connection.sendUTF(data);
                }
                this.opts.setSend(sendRaw);
            });
        });
    }
    get url() {
        return this.opts.endpoint;
    }
    get headers() {
        return this.opts.headers || '';
    }
    connect() {
        let protocols = [], origin = null;
        this.ws.connect(this.url, protocols, origin, this.headers);
        return this.fuConnection;
    }
}
exports.Websocket = Websocket;
//# sourceMappingURL=ws.js.map